searchNodes=[{"ref":"Memcachir.html","title":"Memcachir","type":"module","doc":"Module with a friendly API for memcached servers. It provides connection pooling, and cluster support. Example {:ok} = Memcachir.set(&quot;hello&quot;, &quot;world&quot;) {:ok, &quot;world&quot;} = Memcachir.get(&quot;hello&quot;)"},{"ref":"Memcachir.html#delete/1","title":"Memcachir.delete/1","type":"function","doc":"Removes the item with the specified key. Returns {:ok, :deleted}"},{"ref":"Memcachir.html#exec_parallel/4","title":"Memcachir.exec_parallel/4","type":"function","doc":"Accepts a memcache operation closure, a grouped map of %{node =&gt; args} and executes the operations in parallel for all given nodes. The result is of form {:ok, enumerable} where enumerable is the merged result of all operations. Additionally, you can pass args to supply memcache ops to each of the executions and merge_fun (a 2-arity func) which configures how the result is merged into the final result set. For instance, mget/2 returns a map of key, val pairs in its result, and utilizes Map.merge/2."},{"ref":"Memcachir.html#flush/1","title":"Memcachir.flush/1","type":"function","doc":"Removes all the items from the server. Returns {:ok}."},{"ref":"Memcachir.html#get/2","title":"Memcachir.get/2","type":"function","doc":"Gets the value associated with the key. Returns {:error, &quot;Key not found&quot;} if the given key doesn&#39;t exist."},{"ref":"Memcachir.html#incr/3","title":"Memcachir.incr/3","type":"function","doc":"increments the key by value"},{"ref":"Memcachir.html#list_nodes/0","title":"Memcachir.list_nodes/0","type":"function","doc":"List all currently registered node names, like [:&quot;localhost:11211&quot;]."},{"ref":"Memcachir.html#mget/2","title":"Memcachir.mget/2","type":"function","doc":"Accepts a list of mcached keys, and returns either {:ok, %{key =&gt; val}} for each found key or {:error, any}"},{"ref":"Memcachir.html#mset/2","title":"Memcachir.mset/2","type":"function","doc":"Accepts a list of {key, val} pairs and returns the store results for each node touched"},{"ref":"Memcachir.html#mset_cas/2","title":"Memcachir.mset_cas/2","type":"function","doc":"Multi-set with cas option"},{"ref":"Memcachir.html#set/3","title":"Memcachir.set/3","type":"function","doc":"Sets the key to value."},{"ref":"Memcachir.html#start/2","title":"Memcachir.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Memcachir.Cluster.html","title":"Memcachir.Cluster","type":"module","doc":"Manages cluster state with a regular healthcheck to the configured service discovery mechanism. Configure it with: config :memcachir, :memcachir_cluster, discovery: MyServiceDiscovery Additionally the health check can be configured with config :memcachir, :health_check, 10_000"},{"ref":"Memcachir.Cluster.html#child_spec/1","title":"Memcachir.Cluster.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Memcachir.Cluster.html#get_node/1","title":"Memcachir.Cluster.get_node/1","type":"function","doc":""},{"ref":"Memcachir.Cluster.html#get_nodes/1","title":"Memcachir.Cluster.get_nodes/1","type":"function","doc":""},{"ref":"Memcachir.Cluster.html#init/1","title":"Memcachir.Cluster.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Memcachir.Cluster.html#servers/0","title":"Memcachir.Cluster.servers/0","type":"function","doc":""},{"ref":"Memcachir.Cluster.html#start_link/1","title":"Memcachir.Cluster.start_link/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html","title":"Memcachir.Pool","type":"module","doc":"Dynamic supervisor for connection pooling. If you want to modify the poolboy params, configure it with: config :memcachir, Memcachir.Pool, poolboy: :params Additionally, params that will be sent to the memcachex workers are all found at the top level of :memcachir config"},{"ref":"Memcachir.Pool.html#child_spec/1","title":"Memcachir.Pool.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Memcachir.Pool.html#handle_diff/2","title":"Memcachir.Pool.handle_diff/2","type":"function","doc":""},{"ref":"Memcachir.Pool.html#init/1","title":"Memcachir.Pool.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke DynamicSupervisor.init/1 at the end of their init callback to return the proper supervision flags. Callback implementation for DynamicSupervisor.init/1."},{"ref":"Memcachir.Pool.html#initialize/1","title":"Memcachir.Pool.initialize/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#nodename/1","title":"Memcachir.Pool.nodename/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#pool_config/1","title":"Memcachir.Pool.pool_config/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#poolname/1","title":"Memcachir.Pool.poolname/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#spec_for_node/1","title":"Memcachir.Pool.spec_for_node/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#start_link/1","title":"Memcachir.Pool.start_link/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#start_node/1","title":"Memcachir.Pool.start_node/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#terminate_node/1","title":"Memcachir.Pool.terminate_node/1","type":"function","doc":""},{"ref":"Memcachir.Pool.html#worker_config/1","title":"Memcachir.Pool.worker_config/1","type":"function","doc":""},{"ref":"Memcachir.ServiceDiscovery.html","title":"Memcachir.ServiceDiscovery","type":"module","doc":"Entrypoint to the configured service discovery mechanism"},{"ref":"Memcachir.ServiceDiscovery.html#nodes/0","title":"Memcachir.ServiceDiscovery.nodes/0","type":"function","doc":"Uses the configured service discovery mechanism to get the current cluster"},{"ref":"Memcachir.ServiceDiscovery.Elasticache.html","title":"Memcachir.ServiceDiscovery.Elasticache","type":"module","doc":"Utilizes the elasticache cluster endpoint to infer node addresses"},{"ref":"Memcachir.ServiceDiscovery.Elasticache.html#nodes/0","title":"Memcachir.ServiceDiscovery.Elasticache.nodes/0","type":"function","doc":"Return the node list Callback implementation for Herd.Discovery.nodes/0."},{"ref":"Memcachir.ServiceDiscovery.Hosts.html","title":"Memcachir.ServiceDiscovery.Hosts","type":"module","doc":"Service discovery through a hardcoded list"},{"ref":"Memcachir.ServiceDiscovery.Hosts.html#nodes/0","title":"Memcachir.ServiceDiscovery.Hosts.nodes/0","type":"function","doc":"Return the node list Callback implementation for Herd.Discovery.nodes/0."},{"ref":"Memcachir.Supervisor.html","title":"Memcachir.Supervisor","type":"module","doc":"Supervises the memcachir cluster, pool and registry (which is used internally)"},{"ref":"Memcachir.Supervisor.html#child_spec/1","title":"Memcachir.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Memcachir.Supervisor.html#init/1","title":"Memcachir.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Memcachir.Supervisor.html#start_link/1","title":"Memcachir.Supervisor.start_link/1","type":"function","doc":""},{"ref":"Memcachir.Supervisor.html#supervisor_config/0","title":"Memcachir.Supervisor.supervisor_config/0","type":"function","doc":""},{"ref":"Memcachir.Util.html","title":"Memcachir.Util","type":"module","doc":"Utilities to read configuration."},{"ref":"Memcachir.Util.html#determine_service_discovery/0","title":"Memcachir.Util.determine_service_discovery/0","type":"function","doc":"Keep service discovery inference backwards compatible for now. The cascade is: if :memcachir, :elasticache is set, use Memcachir.ServiceDiscovery.Elasticache if :memcachir, :hosts is set, use Memcachir.ServiceDiscovery.Hosts otherwise use what is configured in :memcachir, :service_discovery (defaulting to Hosts)"},{"ref":"Memcachir.Util.html#parse_hostname/1","title":"Memcachir.Util.parse_hostname/1","type":"function","doc":""},{"ref":"Memcachir.Util.html#retry/3","title":"Memcachir.Util.retry/3","type":"function","doc":""},{"ref":"readme.html","title":"Memcachir","type":"extras","doc":"Memcachir Memcached client for Elixir. It supports clusters and AWS Elasticache."},{"ref":"readme.html#installation","title":"Memcachir - Installation","type":"extras","doc":"defp deps() do ... {:memcachir, &quot;~&gt; 3.2&quot;}, ... end defp application() do [applications: [:logger, :memcachir, ...]] end config :memcachir, hosts: &quot;localhost&quot; The hosts config allows multiple variants: hosts: &quot;localhost:11212&quot; # specify port hosts: [&quot;host1&quot;, &quot;host2&quot;, &quot;host3:11212&quot;] # cluster of servers hosts: [{&quot;host1&quot;, 10}, {&quot;host2&quot;, 30}] # cluster with weights Alternatively you can use the elasticache config option: config :memcachir, elasticache: &quot;your-config-endpoint.cache.amazonaws.com&quot;"},{"ref":"readme.html#configuration","title":"Memcachir - Configuration","type":"extras","doc":"Complete configuration options with default values: config :memcachir, hosts: &quot;localhost&quot;, # memcached options ttl: 0, namespace: nil, # connection pool options pool: [ strategy: :lifo, size: 10, max_overflow: 10]"},{"ref":"readme.html#service-discovery","title":"Memcachir - Service Discovery","type":"extras","doc":"If you don&#39;t want to use the built in service discovery methods (host list, elasticache), you can implement the Herd.Discovery behavior, which just has a single nodes/0 callback. Then configure it in with: config :memcachir, :service_discovery, MyMemcacheServiceDiscovery (NB you&#39;ll need to delete the config :memcachir, :hosts and config :memcachir, :elasticache entries to use a custom service discovery module)"},{"ref":"readme.html#example","title":"Memcachir - Example","type":"extras","doc":"iex&gt; Memcachir.set(&quot;hello&quot;, &quot;world&quot;) {:ok} iex&gt; Memcachir.get(&quot;hello&quot;) {:ok, &quot;world&quot;}"}]